//**************************************************************************
// Nom.....: MAIN.PRG                                                      *
// Projet  : BOBINE                                                        *
// But.....: Programme pour la calculation des mtres sur une bobine      *
//         : de HEINIGER                                                   *
// Date....: 14.02.2017                                                    *
//                                                                         *
// Auteur.......................................: (c) Atelier              *
// email...................: otto@haldi.ch        www.haldi.ch             *
//                                                Haldi Otto               *
//                                                3147  Mittelhusern      *
// Derni?re modification...: 11.03.2017           Tel.: 031 889 10 91      *
//**************************************************************************


#include "windows.ch"                  // Classic windows constant include
#include "ntkacc.ch"                   // Include all that you need to set your acceleration key
#include "wNtk.ch"                     // Common NTK include file
#include "ntkcmd.ch"                   // Common NTK include file
#include "ntkcmdEx.ch"                 // Common NTK include file
#include "wNtkKeys.ch"                 // Include constant for define key
#include "ntkmenus.ch"                 // Include all that you need to create windows menu
#include "ntkedget.ch"                 // Include for Edit Get
#include "ntkbtn.ch"                   // Inlcure for buttons
#include "ntkdll.ch"

// ID's des get's
#define  GET_D1        7001 // id get Largueur
#define  GET_D2        7002 // id get Largueur
#define  GET_D3        7003 // id get Largueur
#define  GET_L         7004 // id get Largueur
#define  GET_P         7005 // id get Largueur

// ID's des boutons
#define  ID_BTN0       8000 // unique id (Button Calc)
#define  ID_BTN1       8001 // unique id (Button Quit)
#define  ID_BTN_EXIT   8002 // unique id (Button Exit)
#define  ID_BTN_PRINT  8003 // unique id (Button Print)
#define  ID_BTN_ABOUT  8004 // unique id (Button About)

// ID's autres
#define  CR Chr(13)    // Retour chariot

// Jnd: Constants pour les Panneaux ds la Status Bar
#define SBP_OFFSET    1
#define SBP_WIDTH     2
#define SBP_ICON      3
#define SBP_TEXT      4
#define SBP_FGCLR     5
#define SBP_BGCLR     6



Static hLogoNtk,hLogoBmp,hStatBar,NbCalc,cStartTime
Static nHHB, nHSB, aSB_Part := {}

Memvar hWnd,aGetlist,aBtnList,aTbBtnList
Memvar hBobine,vDiam1,vHaut,vDiam3,vLarg,vPcent,vLine
Memvar COLDCLR,_NTKDEFFGCOLOR,_NTKDEFBGCOLOR
Memvar aObjFONT2,hObjFONT2



FUNCTION Main()
Local    aMenu,aPopupMenu,lMenRet
Local    hTBBtnFont := NTK_GetStockObject( ANSI_VAR_FONT)  // Font pour la toolbar
Private  hBobine := NTK_ReadPictureToBmp( "images/Bobine.jpg" )
Private  hWnd,vDiam1,vHaut,vDiam3,vLarg,vPcent
Private  aTbBtnList := {}              // tableau pour la gestion de la barre d'outils
Private  aGetList   := {}              // tableau pour la gestion des Get's
Private  aBtnList   := {}              // tableau pour la gestion des boutons

// Dclaration d'un font spcifique
Private aObjFONT2 := { -10,6,0,0,700, .F., .F., .F., 1, 0, 0, 0, 0, "VERDANA" }
Private hObjFONT2 := NTK_CreateFont( aObjFONT2 )

cStartTime := Time()   // Heure actuelle, start


// Dfinition pour la bar des status
nHHB := 45     // Header bar height
nHSB := 34     // Status bar height
// Array pour la bar des status
aSB_Part := {} // Status bar parts. {nOffSet, nWidth, hIcon, cMsg, nBgClr, nFgClr}

// Dfinition des valeurs par dfaut
Aadd( aSB_Part, {   4, 400, IDI_ASTERISK, HB_OemToAnsi("(c) Atelier Otto Haldi - Kapazitt in Meter / 11.03.2017"), NTK_RGB(0,0,0), TRANSPARENT } )
Aadd( aSB_Part, { 402, 250, nil         , "", NTK_RGB(0,0,0), TRANSPARENT } )
Aadd( aSB_Part, { Nil, 100, nil         , {|| TIME() }, NTK_RGB(255,0,0), TRANSPARENT } )


// Test si la cration est OK
if hObjFONT2 == 0
   NTK_MsgBox( , "Erreur cration font VERDENA!" )
   Return(nil)
endif

// Variables pour les get's
NbCalc   := 1
vDiam1   := 40
vHaut    := 15
vDiam3   := 5
vLarg    := 30
vPcent   := 90
vLine    := 96    // Position en pixel

// Cration de la fentre principal. Grandeur fixe!
CREATE WINDOW hWnd              ;
       TITLE "Bobine"           ;      // titre de la fentre
       SIZE 800,600             ;      // grandeur en pixel
       ON EXIT  DoExit()        ;      // fonction appele lorsque l'on quitte le programme
       ON PAINT DoRePaint()            //

if Empty( hWnd )
   NTK_MsgBox( , "Create error Main windows!" )
   Return Nil
endif

aMenu := NtkCreateMenu()
aPopupMenu := NtkCreatePopupMenu()
NtkAppendMenu(aPopupMenu, "PRINT", MF_ENABLED + MF_STRING, "&Print", {|| DoPrint(hwnd) }, "Drucken"  )
NtkAppendMenu(aPopupMenu, "", MF_SEPARATOR)
NtkAppendMenu(aPopupMenu, "QUIT",  MF_ENABLED + MF_STRING, "E&xit",  {|| DoExit(hWnd)  }, "Quitte le programme"  )
NtkAppendMenu(aMenu, "FILE", MF_ENABLED + MF_POPUP, "&Menu", aPopupMenu, "Files operations..." )
NtkAppendMenu(aMenu, "ABOUT", MF_ENABLED + MF_STRING, "&?", {|| DoAbout() }, "About this program..." )
lMenRet := NtkSetMenu(hWnd, aMenu)


// Dclaration des bouttons
aTbBtnList := {}

DECLARE TOOLBAR MEMBER INTO aTbBtnList                                 ;
        ID ID_BTN_EXIT                                                 ;
        CAPTION ""                                                     ;
        SUPER ACCEL KEY K_CTRL_C  ACTION  NTK_ReadEscape(hWnd)         ;
        BITMAP UP "EXIT"  BITMAP GRAYED "EXIT"  SHifT TO 4,4           ;
        MESSAGE "Quitte le programme"+CR+                              ;
                "(ESC / ALT+F4)"

DECLARE TOOLBAR MEMBER INTO aTbBtnList                                 ;
        ID ID_BTN_PRINT                                                ;
        CAPTION ""                                                     ;
        SUPER ACCEL KEY K_CTRL_V  ACTION DoPrint(hWnd)                 ;
        BITMAP UP "PRINT"  BITMAP GRAYED "PRINT"  SHifT TO 4,4         ;
        MESSAGE "Imprime le calcul"+CR+                                ;
                "(Ctrl+P)"

DECLARE TOOLBAR MEMBER INTO aTbBtnList                                 ;
                CAPTION NTK_TB_3DSEPARATOR                             ;
                ID 8092

DECLARE TOOLBAR MEMBER INTO aTbBtnList                                 ;
        ID ID_BTN_ABOUT                                                ;
        CAPTION ""                                                   ;
        SUPER ACCEL KEY K_CTRL_V  ACTION DoAboutW(hWnd)                 ;
        BITMAP UP "ABOUT"  BITMAP GRAYED "ABOUT"  SHifT TO 4,4         ;
        MESSAGE "Info sur le programme"+CR+                            ;
                "(Ctrl+I)"

// On affiche la toolbar dclar ci-dessus!
@ 003,006 CREATE TOOLBAR FROM aTbBtnList       ;
            INTO WINDOW hWnd                   ;
            BUTTON HEIGHT  040                 ;
            BUTTON WIDTH   040                 ;
            BUTTON SPACING 00                  ;
            BUTTON TYPE NTK_BT_OWNERDRAWN      ;
            BUTTON STYLE BS_BOTTOM+BS_RIGHT    ;
            BUTTON FONT hTBBtnFont

/*
@ y,x CREATE TOOLBAR .... BUTTON TYPE NTK_BT_OWNERDRAWN/NTK_BT_STANDARD...
with
@ y,x CREATE TOOLBAR .... BUTTON TYPE NTK_OD_FREESHAPE...
*/


// Dclaration des get's
@ 106,358 GET vDiam1 ID GET_D1         ;
            SIZE 22,50                 ;
            STYLE GS_3DSUNKEN          ;
            VALID NotBlank(vDiam1)     ;
            PICTURE "99999"            ;
            OF hWnd

@ 142,358 GET vHaut ID GET_D2          ;
            SIZE 22,50                 ;
            STYLE GS_3DSUNKEN          ;
            VALID NotBlank(vHaut)      ;
            PICTURE "99999"            ;
            OF hWnd

@ 178,358 GET vDiam3 ID GET_D3         ;
            SIZE 22,50                 ;
            STYLE GS_3DSUNKEN          ;
            PICTURE "99999"            ;
            OF hWnd

@ 214,358 GET vPcent ID GET_P          ;
            SIZE 22,50                 ;
            STYLE GS_3DSUNKEN          ;
            PICTURE "99999"            ;
            OF hWnd

@ 438,144 GET vLarg  ID GET_L          ;
            SIZE 22,50                 ;
            STYLE GS_3DSUNKEN          ;
            PICTURE "99999"            ;
            OF hWnd

// Dclaration des bouttons
@ 466,610  BUTTON "ENDE (Esc)" SIZE 30,160          ;
                  ID ID_BTN1                       ;
                  SUPER ACCEL KEY K_ESC            ;
                  ACTION NTK_ReadEscape(hWnd)      ;
                  STYLE BS_DEFPUSHBUTTON           ;
                  FONT  hObjFONT2                  ;
                  STATE NTK_BT_ENABLE              ;
                  MESSAGE "Programm beenden"       ;
                  OF hWnd

NTK_SetTimerEx( hWnd, 1, 1000, { || StatusBarMsg(hWnd, nHSB, 3) } ) // action: every 1000ms
NTK_ShowWindow( hWnd, SW_SHOW )                // Affiche le fentre courante
NTK_UpdateWindow( hWnd )
NTK_ReadExit( .T. )

do while  NTK_IsWindow(hWnd)
   Read INTO hWnd                           ;  // Complete declaration :
           START FROM 1                     ;
           BUTTON LIST aBtnList             ;
           MSG FONT hObjfont2               ;
           MSG AT 430,  1,630               ; // Pas compris / Place the help message X,Y,Width
           MSG COLOR NTK_RGB(000,000,000)     // Pas compris / Help Text foreground will be black

   do case
   case NTK_LastKey()==K_F8
      StatusBarMsg(hWnd, nHSB)

   case NTK_LastKey()==K_RETURN
      DoCalc(hWnd)
      NTK_UpdateWindow( hWnd )

   case NTK_LastKey()==K_ESC .OR. NTK_LastKey()==K_ALT_F4
      if DoExit()
         exit
      end
   end
enddo


// Fermeture des ressources
CLEAR GETS OF hWnd                     // Fermeture des gets
CLEAR BUTTONS OF hWnd                  // Fermeture des bouttons
NTK_KillTimer(hWnd, 1)                 // Fermeture du timer
NTK_DeleteObject( hLogoBmp )           // Fermeture des objects

// Fermeture de la fentre et on quitte le l'application
CLOSE WINDOW hWnd

Return(.f.)


// Validation des get's : ne doit pas tre vide
//
FUNCTION NotBlank(ValGet)
Local Resume:=.t.
if Empty(ValGet)
   NTK_UpdateWindow( hWnd )
   StatusBarMsg(hStatBar, nHSB, 2, .F., IDI_EXCLAMATION, "Champ ne peut pas tre nul ou vide!", NTK_RGB(255,0,0) )
   Resume := .f.
   REFRESH ALL GETS OF hWnd
else
   StatusBarMsg(hStatBar, nHSB, 2, .F., 0, "")  // Tout baigne !
end
Return(Resume)



// Validation des get's : ne doit pas tre vide
//
FUNCTION DoRepaint(hWnd, nMsg, nWParam, nLParam, hDC)
Local nMaxRow := __NtkMaxRow(hWnd)
Local nMaxCol := __NtkMaxCol(hWnd)

// Cadre des bouttons avec un texte en titre
SET RGB COLOR TEXT NTK_RGB(255,128,0) BACK NTK_RGB(100,100,100)
@ 0,0 SAY HB_OemToAnsi("Lnge eines aufgewickelten Kabels") SIZE nHHB, nMaxCol;
          STYLE DT_SINGLELINE+DT_CENTER+DT_VCENTER;
          FONT NTK_GetStockObject(SYSTEM_FONT);
          INTO CONTEXT hDC

// Cadre Bobine avec titre
SET RGB COLOR TEXT NTK_RGB(0,0,0) BACKGND NTK_RGB(192,192,192)
@ 90,30,480,460 BOX NTK_BXS_SIMPLE INTO CONTEXT hDC
SET RGB COLOR TEXT NTK_RGB(0,0,0) BACKGND NTK_RGB(214,223,247)
@ 70,30,95,460  BOX  NTK_BXS_SIMPLE INTO CONTEXT hDC

@ 75,35 SAY "Genaue Masse eingeben"    ;
         INTO CONTEXT hDC              ;
         TEXTCOLOR NTK_RGB(0,0,0)      ;
         BACKCOLOR TRANSPARENT         ;
         FONT  hObjFONT2               ;
         STYLE DT_CENTER

// Cadre rsultat avec titre
SET RGB COLOR TEXT NTK_RGB(0,0,0) BACKGND NTK_RGB(192,192,192)
@ 90,475,400,770 BOX NTK_BXS_SIMPLE INTO CONTEXT hDC
SET RGB COLOR TEXT NTK_RGB(0,0,0) BACKGND NTK_RGB(214,223,247)
@ 70,475,95,770  BOX  NTK_BXS_SIMPLE INTO CONTEXT hDC

@ 75,480 SAY "Ergebnisse in Meter"    ;
         INTO CONTEXT hDC              ;
         TEXTCOLOR NTK_RGB(0,0,0)      ;
         BACKCOLOR TRANSPARENT         ;
         FONT  hObjFONT2               ;
         STYLE DT_CENTER

@ 96,32 SAY BITMAP hBobine SIZE 382,426  INTO CONTEXT hDC

CreateBarMsg(hWnd, hDC, nHSB)
Return(0)


FUNCTION CreateBarMsg(hWnd, hDC, nHSB)
Local nMaxRow := __NtkMaxRow(hWnd)
Local nMaxCol := __NtkMaxCol(hWnd)
// Local hBmpResize := NTK_LoadBitmap(NULL, OBM_SIZE)       // MS-Windows stocked object/Bitmap
Local np,hIcon,cExpr


// Afficher la box gnrale de la status barre
@ nMaxRow-nHSB,1 , nMaxrow,nMaxCol BOX NTK_BXS_3DRAISED INTO CONTEXT hDC COLOR "N+/N+"


// Afficher le contenu des SB Parts: de 1  p-1.
for nP :=1 to Len(aSB_Part) - 1
    if nP >1
       // Afficher un sparateur vertical
       @ nMaxRow-(nHSB-2), aSB_Part[nP, SBP_OFFSET],;
         nMaxrow-2, aSB_Part[nP, SBP_OFFSET]+2 BOX NTK_BXS_3DRAISED INTO CONTEXT hDC COLOR "N+/N+"
    endif

    if ValType( aSB_Part[nP, SBP_TEXT] )=="B"
       cExpr := EVAL( aSB_Part[nP, SBP_TEXT] )   // Si le msg contient un codeblock on value son expression
    else
       cExpr := aSB_Part[nP, SBP_TEXT]           // sinon, l'affichera tel quel.
    endif

    if !Empty(aSB_Part[nP, SBP_ICON])
       // Si une icne est dfinie
       hIcon := NTK_LoadIcon(NULL, aSB_Part[nP, SBP_ICON])  // MS-Windows stocked object/Bitmap

       @ nMaxRow-nHSB, aSB_Part[nP, SBP_OFFSET]+4 SAY ICON HANDLE hIcon INTO CONTEXT hDC
       @ nMaxRow-(nHSB-2), aSB_Part[nP, SBP_OFFSET]+40 SAY cExpr;
                                 SIZE (nHSB-4), aSB_Part[nP, SBP_WIDTH]-40;
                                 FONT NTK_GetStockObject(ANSI_VAR_FONT);
                                 STYLE DT_SINGLELINE+DT_LEFT+DT_VCENTER;
                                 TEXTCOLOR aSB_Part[nP, SBP_FGCLR]     ;
                                 BACKCOLOR aSB_Part[nP, SBP_BGCLR]     ;
                                 INTO CONTEXT hDC
       NTK_DeleteObject( aSB_Part[nP, SBP_ICON] )  // On libre la ressource.
    else
       // Pas d'icne, afficher uniquement le texte :
       @ nMaxRow-(nHSB-2), aSB_Part[nP, SBP_OFFSET]+4 SAY cExpr;
                                 SIZE (nHSB-4), aSB_Part[nP, SBP_WIDTH]-4;
                                 FONT NTK_GetStockObject(ANSI_VAR_FONT);
                                 STYLE DT_SINGLELINE+DT_LEFT+DT_VCENTER;
                                 TEXTCOLOR aSB_Part[nP, SBP_FGCLR]     ;
                                 BACKCOLOR aSB_Part[nP, SBP_BGCLR]     ;
                                 INTO CONTEXT hDC
    endif
next

// Affichage de la dernire SB Part.
@ nMaxRow-(nHSB-2), nMaxCol-aSB_Part[nP, SBP_WIDTH],;  // sparateur av. la dernire part.
  nMaxrow-2, nMaxCol-aSB_Part[nP, SBP_WIDTH]+2 BOX NTK_BXS_3DRAISED INTO CONTEXT hDC COLOR "N+/N+"

if ValType( aSB_Part[nP, SBP_TEXT] )=="B"
   cExpr := EVAL( aSB_Part[nP, SBP_TEXT] )
endif
@ nMaxRow-(nHSB-2),nMaxCol-aSB_Part[nP, SBP_WIDTH]+4 SAY cExpr;
                   SIZE (nHSB-4), aSB_Part[nP, SBP_WIDTH]-6  FONT NTK_GetStockObject(SYSTEM_FONT);
                   STYLE DT_SINGLELINE+DT_CENTER+DT_VCENTER;
                   TEXTCOLOR aSB_Part[nP, SBP_FGCLR];
                   BACKCOLOR aSB_Part[nP, SBP_BGCLR];
                   INTO CONTEXT hDC

// NTK_DeleteObject(hBmpResize)           // Fermeture des ressources
Return(nil)




// Fonction pour quitter l'application
//
FUNCTION DoExit()
if NTK_MsgBox( hWnd,;
   "On quitte le programme aprs : "+ ELAPTIME(cStartTime,Time()),"Atelier Haldi Otto",;
   MB_OKCANCEL+MB_ICONQUESTION  ) == IDOK
   NTK_ReadEscape()
   NTK_PostQuitMessage(0)
   Return(.T.) // On quitte
endif
Return(.F.)    // On reste



// Afficher une info sur l'application
//
FUNCTION DoAbout(hwnd, cDispMsg)
NTK_MsgBox( hWnd,"Atelier Ho","A propos",;
            MB_OK+MB_ICONASTERISK )
Return(nil)



// Fonction pour l'impression
//
FUNCTION DoPrint(hwnd, cDispMsg)
Alert(HB_OemToAnsi("Function non dfinie")+CR+;
      "(c) Atelier Otto Haldi")
Return(nil)



// Afficher le calcul
//
FUNCTION DoCalc(hwnd)
Local Haut,vDiam2,Spir,Metr
Local Diff  := 0
Local TotLg := 0

if Empty(vDiam1) .or. Empty(vHaut) .or. Empty(vDiam3) .or.Empty(vPcent) .or.Empty(vLarg)
   StatusBarMsg(hStatBar, nHSB, 2, .F., IDI_EXCLAMATION, "ACHTUNG: Zahlen mit null!", NTK_RGB(255,0,0) )
else
   // vDiam1 = Diamtre extieur en cm
   // vHaut  = Hauteur entre diamtre intrieur et extrieur en cm
   // Haut   = Hauteur en mm
   // vDiam2 = Diamtre intrieur du touret cm
   // vDiam3 = Diamtre du cble en mm
   // vPcent = Remplissage
   // vLarg  = Largueur int. du touret en cm

   Haut   := vHaut * 10                        // Hauteur en mm
   vDiam2 := vDiam1-(2*vHaut)                  // Calcul du diamtre intrieur
   Spir   := (vLarg*10)/vDiam3                 // Nombre d'enroulement par largueur
   Spir   := Spir -1                           // On enlve une spire!

   // Metre par couche
   while Diff < Haut - (vDiam3 * 2)
      Metr   := ((vDiam2*3.14)*Spir)/100       // Diamtre x Nb de spire sur 100 pour m
      vDiam2 := vDiam2 + ((vDiam3/10)*2)       // Ajoute une couche
      TotLg  := TotLg + Metr                   // Addition des couche
      Diff   := Diff + vDiam3
   end

   TotLg = (TotLg/100) * vPcent                // Calcul du remplissage en %

   if vLine < 380
      @ vLine,480 SAY Str(NbCalc,2) INTO WINDOW hWnd  // jnd: C'est tjrs mieux de spcifier le handle dans quelle
      @ vLine,500 SAY Str(vDiam1,5) INTO WINDOW hWnd  // jnd: fentre on doit peindre, lorsqu'on agit en dehors de
      @ vLine,550 SAY Str(vDiam2,5) INTO WINDOW hWnd  // jnd: la paint procdure definie au CREATE WIN.
      @ vLine,600 SAY Str(vDiam3,5) INTO WINDOW hWnd  // jnd: Cd: En cas d'allocation/usage dynamique d'un DC.
      @ vLine,650 SAY Str(vLarg,5)  INTO WINDOW hWnd  // jnd: (comme c le cas ici)
      SET COLOR TO R+/W+
      @ vLine,703 SAY Str(TotLg,8,1) INTO WINDOW hWnd // jnd:
      vLine := vLine +20
      NbCalc++
   end
end
Return(nil)



FUNCTION StatusBarMsg(hWnd, nHSB, nPart, lSmothRedraw, nIcon, cMsg, nFgColor, nBgColor)
Local nTop, nLeft, nBottom, nRight

Default lSmothRedraw To .F.  // .T. Less flicking

if Empty(nPart) .OR. nPart <1 .OR. nPart >Len(aSB_Part)
   // Repaint the whole Status Bar
   NTK_InvalidateRect(hWnd)
   Return(NIL)
endif

if nIcon != Nil
   aSB_Part[nPart, SBP_ICON] := nIcon          // Changer l'icone pour la SB Part desire
endif

if cMsg != Nil
   aSB_Part[nPart, SBP_TEXT] := cMsg           // Changer le msg pour la SB Part desire
endif

if nFgColor != Nil
   aSB_Part[nPart, SBP_FGCLR] := nFgColor      // Changer la couleur du texte pour la SB Part desire
endif

if nBgColor != Nil
   aSB_Part[nPart, SBP_BGCLR] := nBgColor      // Changer la couleur du fond du texte pour la SB Part desire
endif

// Retrieve coordinates of the specified part
nTop := __NtkMaxRow(hWnd)-(nHSB-2)

if aSB_Part[nPart,SBP_OFFSET]==NIL .OR. aSB_Part[nPart,SBP_OFFSET] <0
   // Last part: offset is nil or lesser than 0
   nLeft := __NtkMaxCol(hWnd) - aSB_Part[nPart,SBP_WIDTH]
else
   nLeft := aSB_Part[nPart,SBP_OFFSET]
endif

nBottom := nTop + (nHSB-2)
nRight  := nLeft + aSB_Part[nPart,SBP_WIDTH]

// Refresh the specified part.
NtkRepaint(hWnd, nTop, nLeft, nBottom, nRight, lSmothRedraw)
Return(nil)



FUNCTION DoAboutW(hwnd, cDispMsg)
Local hWndAbout

CREATE WINDOW hWndAbout                 ;
       TITLE "About"                   ;
       AT 0,0 SIZE 400,250             ;
       ON EXIT  NTK_SendQuitEvent()


ACTIVATE WINDOW hWndAbout CENTER       // Display Main window and its controls

InKey(5)


CLOSE WINDOW hWnd
Return(Nil)